<?php

   ###################################################################
   #
   #   nanoweb online configuration script
   #
   #   <mario@erphesfurtde>

   #   directives which are commented out in the distributed config
   #   files shouldn't be listed here, as they are set to 0 if one
   #   pushes [Save] without noticing this

   #<off>#   $FORCE_LANG = "en";

   #-- init vars
   $PHP_SELF = $HTTP_SERVER_VARS["SCRIPT_NAME"];
   $_REQUEST = array_merge($_REQUEST, $HTTP_GET_VARS, $HTTP_POST_VARS);
   $DOS_HOST = stristr(php_uname(), "Windows");
   error_reporting(65535);
   set_magic_quotes_runtime(0);

   #-- no running nanoweb -> php (only?)
   $page = @$_REQUEST["page"];
   if (empty($page)) {
      if (strstr(@$HTTP_SERVER_VARS["SERVER_SOFTWARE"], "nanoweb") === false) {
         $page = "PHP/PHP";
      }
      else {
         $page = "NW/nanoweb";
      }
   }
   @list($which, $config_page) = explode("/", $page, 2);

   $T = array(
      "NW" => array(
         "CONFIG_DIR" => search_dir(array("/etc/nanoweb", "/usr/etc/nanoweb", "/usr/local/etc/nanoweb", "C:/nanoweb", "C:/Program Files/nanoweb")),
         "CONFIG_FILE" => "nanoweb.conf",
         "DEFAULT_SECTION" => "global",
         "DOCDIR" => ($d = "/manual"),
         "DOC" => "$d/index.html",
         "DOCREF" => "$d/core.html#"
      ),
      "PHP" => array(
         "CONFIG_DIR" => search_dir(array(dirname(get_cfg_var("cfg_file_path")), "/etc/php4/cli", "/etc/php4/cgi", "/etc/php4/nanoweb", "/etc/php4/apache", "/etc/php/cgi", "/etc/php4", "/etc/php", "/usr/local/etc/php4", "C:/PHP", "C:/PHP4", "C:/Program Files/PHP")),
         "CONFIG_FILE" => "php.ini",
         "DEFAULT_SECTION" => "PHP",
         "DOC" => "http://www.php.net/manual/en/",
         "DOCREF" => "http://www.php.net/manual/en/configuration.php#ini."
      )
   );
   $DEFAULT_SECTION = $T[$which]["DEFAULT_SECTION"];

   $configuration_pages["NW"] = array(
	"nanoweb" => array(
            "html" => '<img src="nanoweblogo.gif" width="200" height="60" align="right" alt="nanoweb logo" valign="top" border="1">'."
                      This tool is intended for quick initial setup of nanoweb.
                      It is often much easier and faster to edit the
                      well documented configuration files and it is in
                      fact impossible to configure each and every option
                      through this interface, so an editor is necessary for
                      fine-tuning.
                      <br><br> In order to be able to use this tool you must
                      make the config files writeable on Linux/UNIX
                      machines (not Windows):<br><TT>chmod a+rw
                      {$T[$which]['CONFIG_FILE']}</TT><br><br>This can be revoked by
                      pushing 'Lock Config' on this page after you have
                      finished setup.<br><br>You need to select [Save] on
                      every page if you did changes to it.<br><br><input
                      type=\"submit\" name=\"lock\" value=\"Lock Config\">
                      <input type=\"submit\" name=\"apply\"
                      value=\"Apply Config\">\n"
        ),
        ":General" => array(
            "html" => "The main server needs a default DNS name which gets
                      send back if a client doesn't know it yet. An alias
                      name may contain asterisks. You cannot just invent
                      names here without telling your operating system (see
                      /etc/hosts or C:\winnt\hosts).<br>",
            "ServerName" => "string",
            "ServerAlias" => "multiple",
            "ServerAdmin" => "string",
            "html_docroot" => "The document root is the base directory of
                      all files which are available through the nanoweb
                      server:<br>",
            "DocumentRoot",
            "html_directoryindex" => "The file that gets delivered in favour
                 of a directory listing can be set using the DirectoryIndex
                 directive. Multiple file names may be given here separated
                 by spaces:<br>",
            "DirectoryIndex",
            "html_defcontenttype" => "When nanoweb cannot determine which
                 type a file is of, it will use following value to tell
                 the client (browser):<br>",
            "DefaultContentType",
            "html_singleprocessmode" => "Because Windows&trade; doesn't
                 support process forking like UNIX nanoweb must run on this
                 platform in the somewhat slower ",
            "SingleProcessMode" => "False|True",
            "html_servermode" => "You're strongly encouraged to have a look into
                 the READMEs before changing the ",
            "ServerMode" => "standalone|inetd|",
            "html_user" => "If you don't want nanoweb to run with superuser
                        privileges keep the default www-data as ",
            "User" => "string",
            "Group" => "string"
        ),
        ":Technical" => array(
            "html" => "nanoweb needs to bind to at least to one IP address
                      and a TCP port (80 is the default for webservers) to
                      listen for incoming connections.<br><br>",
            "ListenInterface" => "string",
            "ListenPort" => "string",
            "html_listenqueue" => "A number of incoming requests can be
                 delayed (until they are processed) depending on the size
                 of the ",
            "ListenQueue" => "string",
            "html_keepalive" => "Keep-Alive is a feature of modern HTTP
                 clients to receive files step by step. Use this directive
                 to give a maximum timout for such requests (just set to 0
                 to disable it fully):<br>",
            "KeepAlive" => "string",
            "html_rqtimeout" => "Some browser crash from time to time and
                 thus cannot complete their requests after they already
                 established and prepared a connection. To prevent
                 nanoweb from waiting for unfinished requests this directive
                 gives a timeout for these cases:<br>",
            "RequestTimeout" => "string",
            "html_childlife" => "From time to time child processes need to
                 be restarted because they may already be trapped in some
                 neverending loop. Give an amount of seconds after which
                 every child shall be recreated.<br>",
            "ChildLifeTime" => "string",
            "html_tmp" => "Set this to where nanoweb is allowed to saves some files temporarily:<br>",
            "TempDirectory" => "/tmp"
        ),
        ":File Names" => array(
            "html" => "The filenames of the per-directory
                      configuration files are not hardcoded, it's up to your
                      choice how they are called.<br><br>",
            "html_auth" => "These files contain the authentication (password)
                      infos used by nanoweb's HTTP auth mechanism:<br>",
            "AuthFile" => "string",
            "html_htaccess" => "If you want to reuse the per-directory
                      configuration files of apache for example you may
                      want to change this to <b>.htaccess</b>:<br>",
            "AccessFile" => "string"
        ),
        ":Mime Types" => array(
             "html_mimetypes_file" => "nanoweb initially fetches it's mime
             types from the system wide mime registry file found on all
             recent Linux systems, so there's actually no need to care about
             file extension mappings.<br><br>",
             "MimeTypes" => "string"
        ),
        ":Logging" => array(
            "html" => "nanoweb supports various ways to log nearly all
                      activities. If you want to enable logging to a MySQL
                      database, please refer to the manual on how to setup
                      the according extension module.<br><br>",
            "Log" => "string",
            "html_serverlog" => "The ServerLog will be feeded with almost
                 ALL informations (including page hits):<br>",
            "ServerLog" => "string",
            "html_dnslookup" => "You may want to keep the DNS lookups
                 (for hostnames instead of IP addresses in server logs)
                 disabled as this slows down nanoweb:<br>",
            "HostnameLookups" => "Disabled|Enabled",
            "html_pid" => "The PidFile holds the process id on Linux/UNIX
                 machines, which eases killing the server for nanoctl.<br>",
            "PidFile" => "string",
            "html_2" => "LoggerProcess, LoggerUser/Group can only be set
                        in the config file.<br><br>",
            "html_modstdlog" => "If you want the log to be printed to the
                 console (window) the module
                <A HREF=\"".$T["NW"]["DOC"]."/mod_stdlog.html\">mod_stdlog</A>.<br>
                must be loaded.<br>",
            "LogToConsole" => "boolean"
        ),
	":CGI Setup" => array(
            "html_pe" => "The ParseExt directive
                      defines which CGI interpreter shall be invoked for
                      which file extension.<br>",
            "ParseExt" => "multiple",
            "html_pi" => "The pathinfo is an additional information holder
                  besides the query string (GET) or the POST variables.
                  It is often used in favour of GET variables
                  because \"script.php?a=x&b=1&cd=234\" frightens nearly
                  all search engines, while the pathinfo is harmless.<br>",
            "AllowPathInfo" => "boolean",
            "html_pathinfotryext" => "You probably want to note every CGI
                      extension in here too, as this enables you to leave
                      out extensions when referring to a CGI with an incomplete
                      URI and without the need for mod_multiviews:<br>",
            "PathInfoTryExt" => "multiple",
            "html_phpbug" => "The PHP interpreter still has a bug, which
                     makes it trash the \$PHP_SELF variable if one
                     passes a \$PATH_INFO. If this directive is enabled
                     you won't be able to use PATH_INFO, if disabled you
                     still can use SCRIPT_NAME in favour of PHP_SELF:<br>",
            "CGIFilterPathInfo" => "boolean",
            "FastCGIFilterPathInfo" => "boolean"
        ),
        ":Security" => array(
            "html_aesl" => "Webservers only should allow access to files
                  below the docroot (or the docroot of a virtual hosts). You
                  may however allow nanoweb to serve files which are
                  referred to by UNIX's symbolic links if the owner of the
                  symlink also owns the file linked to:<br>",
            "AllowExtSymlinks" => "boolean",
            "html_ignoredotfiles" => "Files whose name starts with a dot are
                  treated invisible by most UNIX applications; nanoweb for
                  example keeps per-directory configuration and password data
                  in files of this kind. You probably don't want anybody to
                  be able to retrieve such files:<br>",
            "IgnoreDotFiles" => "No|Yes"
        ),
        ":Miscellaneous" => array(
            "html_alias" => "Use the Alias directive to assign virtual
                  directory names to existing ones. These aliased directories
                  can be accessed from any virtual host independent from
                  any following configuration directives:<br>",
            "Alias" => "multiple",
            "html_errordocuments" => "A custom info page may be shown
                  instead of nanoweb's built-in error messages:<br>",
            "ErrorDocument" => "multiple",
            "html_addheader" => "This directive allows you to send arbitrary
                  HTTP headers to the client:<br>",
            "AddHeader" => "multiple",
            "html_userdir" => "User directories are accessible via
                  <b>http://server/~user</b> if the user created following
                  subdirectory in his homedir.<br>",
            "UserDir" => "string"
         /* "html_include" => "The Include directive allows to split the configuration
                      into different files; <tt>nanoweb.conf</tt>,
                      <tt>modules.conf</tt> and <tt>vhosts.conf</tt> are the
                      default ones, and you probably don't want much more
                      of these!<br>",
            "Include" => "multiple"
         */
        ),
        "Modules" => array(
            "html" => "Following extension modules are currently set to be
                      loaded on nanoweb startup. Note that entries, which
                      are commented out, don't get shown here (yet). <br>
                      Have a look in the manual for an overview of all
                      <a href=\"{$T["NW"]["DOCDIR"]}/modules.html\">available
                      modules</a>.<br><br>",
            "LoadModule" => "multiple"
        ),
        ":Gzip Encoding" => array(
            "html" => "Nearly all HTTP transfers can be accelerated if the
                      requested content is encoded using the internet
                      standard compression method gzip (also known as
                      zlib format) as all recent browsers support
                      transparent compression. This speeds up the transfer
                      as there is usually less packet loss due to usually
                      less tcp/ip packages, and most important: many users
                      still use slow modem dialup connections.<br><br>",
            "GzipEnable" => "boolean",
            "html_2" => "Only transfer compressed if it doesn't seems to be
                     already compressed:<br>",
            "GzipMaxRatio" => "string"
        ),
        ":FileBrowser" => array(
            "html" => "The filebrowser extension module generates directory
                      listings where no default file (see DirectoryIndex)
                      is available. The output may be tweaked by various
                      options:<br>",
            "FileBrowser" => "Disabled|Enabled",
            "FBSortOrder" => "name|size|date|name desc|size desc|date desc",
            "FBWelcomeFile" => "string",
            "FBDescFile" => "string",
            "html_icons" => "The /icons/ directory is an aliased one which can be reached from every vhost,
                  that way it is much easier for mod_filebrowser to map icons to file types:<br>",
            "FBIconByType" => "multiple",
            "FBIconDirectory" => "string",
            "FBIconDefault" => "string"
        ),
        ":Mispell" => array(
            "html" => "Correct misspelled URLs automagically (internal
                 redirect) or present an error page with correct URL:<br>",
            "MispellAction" => "|advice|redirect"
        ),
        ":MultiViews" => array(
            "html" => "The multiviews module extends nanoweb with
                      transparent content negotiation (this means serving
                      a file out of a bunch of variants that best matches
                      the clients preferences).<br>It partially helps with
                      RVSA/1.0<br><br>",
            "html_1" => "You may want to set the language that is the primary
                        one on your web page:<br>",
            "LanguagePriority" => "string",
            "html_2" => "Additional server-side preferences come into use,
                        when the client is unwillingly to state which 
                        file types it supports:<br>",
            "OtherPriority" => "multiple",
            "html_4" => "Following directive is also used by mod_rewrite:<br>",
            "ReflectRewriting" => "boolean"
        ),
        ":Status" => array(
            "html" => "mod_status allows you to view some <a
                 href=\"/server-status?detailed\">informations about
                 the running server</a> online.<br>
                 Please refer to the <a href=\"{$T["NW"]["DOC"]}\">manual</a> for
                 the available info pages.<br><br>",
            "html_sah" => "For security reasons you only should allow
                 local users access to these status pages. An incomplete
                 IP address is treated as match pattern:<br>",
            "StatusAllowHost" => "multiple"
        ),
        ":StdoutLog" => array(
            "html" => "The module mod_stdlog prints the log to the console
                      nanoweb.php was run from. This only works if you
                      didn't used nanoctl to start the server.<br><br>",
            "LogToConsole" => "boolean"
        ),
        ":MySQL Logging" => array(
            "html" => "mod_mysqllog writes the server log into a database
                 (instead of to some file, which the standard logging
                 functions do).<br>
                 The according table is automagically created if everything
                 is set up correctly:<br><br>",
            "MySQLLogHost" => "string",
            "MySQLLogDatabase" => "string",
            "MySQLLogUser" => "string",
            "MySQLLogPassword" => "string"
        ),
        ":Proxy" => array(
            "html" => "mod_proxy is an internal proxy for nanoweb. Proxy
                 servers are often used to be able to overcross a firewall,
                 the nanoweb proxy is primarily a caching one.<br><br>",
            "CacheDir" => "string",
            "AllowIP" => "string"
        ),
        ":LoadLimit" => array(
            "html" => "mod_load_limit stops nanoweb from further serving pages
                      if the server gets too slow.<br><br>",
            "LoadLimit" => "string"
        ),
        ":Brainfuck" => array(
            "html" => "Brainfuck server pages (.bsp) module.<br><br>",
            "BSPAllowSource" => "boolean",
            "html_2" => "Please refer to the manual, READMEs and Google for
                 further informations.<br><br>"
        ),
	"Virtual Hosts" => array( 
            "html" => "A virtual host always has server name and a docroot
                      different from the main server. Many of the directives
                      that can be used within the main server configuration
                      section are allowed for virtual hosts too.<br><br>",
            "html2" => 'DNS name for the new virtual host:<br><input size="42" name="add_vhost"> <input type="submit" value="Add" name="save"> '
        )
   );

   $CONFIGPAGE_ADD_NW_VHOST = array(
               "html" => "Directives in a virtual host section may override
                    values from the main server configuration.<br><br>",
               "html_2" => "Without a separate directory tree a virtual
                    host section would be completely senseless:<br>",
               "DocumentRoot" => "string",
               "html_3" => "Match pattern for additional server names,<br>",
               "ServerAlias" => "multiple",
               "html_4" => "If you would like to have a separate server log for this
                    virtual host, just give a different filename here.<br>",
               "Log" => "string"
   );
   $CONFIGPAGE_ADD_DOC = array(
               "html_seedoc" => "Please have a look at the
               <a href=\"{$T[$which]["DOC"]}\">online manual</a> for
               informations on these configuration directives.<br><br>"
   );

   $configuration_pages["PHP"] = array(
        "PHP" => array(
            "html" => "The <nobr><b>P</b>HP</nobr> <nobr><b>H</b>ypertext</nobr>
                      <nobr><b>P</b>rocessor</nobr>.<img src=\"{$PHP_SELF}?=" .
                      php_logo_guid() . "\" align=\"right\" alt=\"PHP Logo\"><br>  It wasn't originally
                      planned to make PHP configurable with nanoconfig, so
                      don't expect any miracles!<br><br>You have to make the
                      php.ini writeable as you did with the nanoweb
                      configuration files (<tt>chmod a+rw php.ini</tt>) to
                      be able to adjust the directives.<br><br>",
            "html_engine" => "PHP can be enabled or disabled on a per
                      directory basis, that's what this flag is for:<br>",
            "engine" => "magic",
            "html_exposephp" => "For security concerns some people don't
                      want to tell the world that they're actually using PHP.
                      Setting this flag only makes sense if none of the
                      scripts is referred with the default trailing .php (add
                      a ParseExt or use mod_rewrite to hide it effectively):<br>",
            "expose_php" => "magic",
            "html_phptags" => "PHP code is enclosed in the XML-style
                      <nobr><tt><b>&lt;?php ... ?&gt;</b></tt></nobr> tag, but most
                      people want to leave out the php after the question
                      mark<br><tt>&lt;?...?&gt;</tt> ", 
            "short_open_tag" => "auto",
            "html_asptags" => " ASP tags are rather unusual<br><tt>&lt;%...%&gt;</tt> ",
            "asp_tags" => "auto",
            "default_mimetype" => "string",
            "default_charset" => "string"
        ),
        ":Files/Paths" => array(
            "html_inclpath" => "Give a list of colon separated directories
                  to search for included files:<br>",
            "include_path" => "string",
            "html_prepend" => "Following files are automagically included
                  into every executed script (useful for setup of site
                  specific runtime defaults):<br>",
            "auto_prepend_file" => "string",
            "auto_append_file" => "string",
            "html_urlfopen" => "PHP allows you to use the standard file access
                   function calls to retrieve http:// and ftp:// resources
                   (reading only). This is a very powerful feature, but can
                   lead easily to security holes.<br>",
            "allow_url_fopen",
            "html_5" => "The following directives are compatibility ones.
                  Just don't care if you use nanoweb.<br><br>",
            "doc_root" => "string",
            "user_dir" => "string",
            "extension_dir" => "string"
        ),
        ":Variables" => array(
            "html" => "PHP once was known to be an ease to web development.
                  For security reasons some of its behaviour has changed
                  through the last versions. You can however gain
                  compatibility with older versions with some of these
                  options:<br><br>",
            "html_buffer" => "If you want all GET, POST and COOKIE variables
                  to be automagically accessible in global name space
                  (else these variables are accessible through
                  \$_REQUEST[] or \$_GET[]), you probably want to enable ",
            "register_globals" => "auto",
            "html_varorder" => "Precedence order for Get, Post, Cookie,
                  Session and Environment variables:<br>",
            "variables_order" => "string",
            "html_argcargv" => "\$argc and \$argv are only useful to
                  standalone non-www scripts (CLI):<br>",
            "register_argc_argv" => "auto",
            "html_precision" => "floating point variables` ",
            "precision" => "string",
            "html_magicquotes" => "Enabling magic quotes will lead to
                  escaped meta characters in variables that come from
                  outside or are to be send out:<br>",
            "magic_quotes_gpc" => "magic",
            "magic_quotes_runtime" => "magic",
            "magic_quotes_sybase" => "magic"
        ),
        ":Output" => array(
            "html" => "Every piece of output that comes from non-script
                  areas or echo() may be buffered or feed through output
                  handlers.<br><br>",
            "html_buffer" => "You may set a buffer size (default for on is
                  4096 bytes) which allows you to send headers() even if
                  something already has been printed out.<br>",
            "output_buffering" => "Off|On|1024|2048|4096|8192|16384|32768",
            "output_handler" => "string",
            "html_zlibout" => "Instead of specifying one of the generic
                  output handlers above you may want to auto compress your
                  pages with the zlib output handler (this is what
                  mod_gzip does for static pages):<br>",
            "zlib.output_compression" => "Off|On",
            "html_imflush" => "If output handler active, flush the buffer after every
                  echo() or non-php-script page parts:<br>",
            "implicit_flush" => "auto"
        ),
        ":Safe Mode" => array(
            "html" => "The PHP Safe Mode allows to restrict availability
                  of functions or access to not owned files and directories.<br>",
            "safe_mode" => "auto",
            "html_gid" => "Check script's GID (group id on Linux/UNIX) also
                  against accessed file, additionally to the standard UID
                  (user id) test.<br>",
            "safe_mode_gid" => "auto",
            "html_dirs" => "The uid/gid doesn't need to match for following
                  two directories:<br>",
            "safe_mode_include_dir" => "string",
            "safe_mode_exec_dir" => "string",
            "safe_mode_allowed_env_vars" => "string",
            "safe_mode_protected_env_vars" => "string",
            "html_disfunc" => "This directive is also in effect, when safe
                  mode is not enabled:<br>",
            "disable_functions" => "string",
            "html_dl" => "The dl() function allows to load extension modules
                  at runtime:<br>",
            "enable_dl" => "auto"
        ),
        ":Errors/Log" => array(
            "html" => "Errors may be suppressed or redirected determined by
                 following config directives,<br><br>",
            "html_err" => "Following value may be changed in each script by
                 using the error_reporting() function call; however some
                 errors are produced in load stage (parsing errors for
                 example) and thus cannot be affected later.<br>
                 E_ALL, E_ERROR, E_WARNING, E_PARSE, E_NOTICE,
                 E_COMPILE_ERROR, E_CORE_ERROR are only some of the available
                 bits which may be combined with the binary OR: |<br>",
            "error_reporting" => "string",
            "html_displayerr" => "Mixing error messages into standard output
                 (web page) is very handy for development but discouraged for
                 production web sites:<br>",
            "display_errors" => "auto",
            "display_startup_errors" => "auto",
            "html_htmlerrors" => "Display errors using HTML markup (red color for example).
                 You may want to set the error output enhancements in the php.ini
                 after enabling this:<br>",
            "html_errors" => "auto",
            "log_errors" => "auto",
            "track_errors" => "auto",
            "html_errorlog" => "Log errors to <b>syslog</b> (available in
                 NT but not in Windows 4.x) or to the file specified here:<br>",
            "error_log" => "string",
            "warn_plus_overloading" => "auto",
            "allow_call_time_pass_reference" => "auto"
        ),
        ":Misc" => array(
            "html" => "Execution of scripts can be restricted in time
                 and memory usage.<br><br>",
            "memory_limit" => "string",
            "max_execution_time" => "string",
            "html_maxpost" => "Too huge POST requests may trash the server or slow
                  down your scripts considerably, and thus are often used to
                  fault webservers.<br>",
            "post_max_size" => "string",
            "html_fileup" => "HTTP ",
            "file_uploads",
            "upload_max_filesize",
            "html_from" => "Anonymous FTP connections require an email
                 address to be send instead of a password:<br>",
            "from",
            "html_y2k" => "not really useful ",
            "y2k_compliance"
        ),
        "Extensions" => array(
            "html" => "Many of the PHP extensions are now built-in; however
                  some of them must be explicitly loaded and registered within
                  the PHP core.<br><br>",
            "extension" => "multiple",
            "extension_dir" => "string"
        )
   );




   #-- other language configuration pages
echo "PRELANGS ";
   if (($langs = $FORCE_LANG) || ($langs = getenv("HTTP_ACCEPT_LANGUAGE"))
|| ($langs = "fr, eo, nl, de, en, fr")) {
echo "LANGS";
      $lpref = array();
      foreach (explode(",", $langs) as $langq) {
         preg_match('/^\s*(\w\w).*?[\s;]+qs?=([.\d]+)/', $langq . "; q=1", $uu);
         $lpref[strtolower($uu[1])] = $uu[2];
echo "foundq: {$uu[1]}\n<br>";
      }
      arsort($lpref);
      $lpref = array_keys($lpref);
   
      foreach ($lpref as $LANG) {
echo "scanlang: {$LANG}\n<br>";

         if (($LANG == "en")) { 
            break;
         }
         if (! is_file($cp_lang_php = "nanoconfig-$LANG.php")) {
            continue;
         }

         $cp_en = $configuration_pages;
         include($cp_lang_php);

         #-- go thru main config parts ("NW", "PHP")
         foreach ($cp_en as $m => $main) {
            #-- go thru pages
            foreach ($main as $p => $page) {
               #-- a page missing?
               if (empty($configuration_pages[$m][$p])) {
                  $configuration_pages[$m][$p] = $page;
               }
               else {
                  #-- add missing directives and/or help
                  $prevd = $prevddesc = "";
                  foreach ($page as $d => $ddesc) {
                     if (strpos($d, "html") === 0) {
                        $prevd = $d;
                        $prevddesc = $ddesc;
                     }
                     elseif (empty($configuration_pages[$m][$p][$d])) {
                        if ($prevd) {
                           $configuration_pages[$m][$p][$prevd] == $prevddesc;
                           $prevd = $prevddesc = "";
                        }
                        $configuration_pages[$m][$p]["html_$d"] = $ddesc;
                     }
                  }
               }
            }#foreach(page)
         }#foeach(part)

         #-- missing directives transfered from english ones
         unset($cp_en);

         break; # we don't want to overwrite data with another lang file
      }
   }




   # == ini files - read and write ========
   $directive = @$_REQUEST['directive'];  # new directive values
#-- echo "<pre>";print_r($directive);echo "</pre>";

   # == lock action ============
   if (@$_REQUEST["lock"]) {
      if (! $DOS_HOST) {
         $cdir = opendir($T[$which]["CONFIG_DIR"]);
         while ($cfile = readdir($cdir)) {
            if ($cfile[0] != ".") {
               chmod($T[$which]["CONFIG_DIR"] . "/" . $cfile, 0644);
               @$_MESSAGE .= "$cfile ";
            }
         }
         closedir($cdir);
         $_MESSAGE = "Set $_MESSAGE to not-writable.<br><br>";
      }
      else {
         $_MESSAGE = "Your operating system supports no file permissions, so the config files cannot be locked.<br><br>";
      }
   }

   # == apply action =============
   elseif (@$_REQUEST["apply"]) {
      if (! $DOS_HOST) {
         @exec("/usr/bin/killall -HUP nanoweb.php");
         $_MESSAGE = "You need to restart nanoweb for the changed configuration
                     to take effect.<br><br>";
      }
      else {
         #-- @exec("C:/nanoweb/nanoctl restart"); #-???-
      }
   }

   # == strip empty "new" directives
   remove_empty_nodes($directive);

   # ==  read and update config files ====================================

   $cf[$DEFAULT_SECTION]["include"] = array($T[$which]["CONFIG_DIR"] . "/" . $T[$which]["CONFIG_FILE"]);
   $cf_section = $DEFAULT_SECTION;
   $cf_already = array();

   function next_config_file() {
      global $cf_already, $cf, $cf_section, $DEFAULT_SECTION;
      foreach ($cf[$DEFAULT_SECTION]["include"] as $cf_file) {
         if (empty($cf_already[$cf_file])) {
            $cf_already[$cf_file] = 1;
            return($cf_file);
         }
      }
   }

   function search_dir($dirs) {
      foreach ($dirs as $d) {
         if (file_exists($d) && is_dir($d)) {
            return($d);
         }
      }
      return($dirs[0]);
   }

   function add_missing_directives($last_cf_directive = "[]") {
      global $cf_section, $directive, $new, $cf;
      if (isset($directive[$cf_section]))
      foreach ($directive[$cf_section] as $dname => $darray) {
         if (($last_cf_directive === "[]") ||
             (strtolower($dname) == $last_cf_directive)) {
            #--echo "adding lost directive [$cf_section] $dname / '$last_cf_directive'<br>";

            foreach($darray as $di => $dval) {
               $new[] = "{$dname} = {$dval}\n";
               @$cf[$cf_section][strtolower($dname)][] = $dval;
            }
            unset($directive[$cf_section][$dname]);
         }
      }
   }

   function remove_empty_nodes(& $array) {
      if (! empty($array))
      foreach ($array as $id => $sub) {
         if (is_string($sub) && (empty($sub)) && ($sub !== "0")) {
            unset($array[$id]);
         }
         elseif (is_array($sub)) {
            remove_empty_nodes($array[$id]);
         }
      }
   }


   /* do once */ { 
      $cf_already = array();  # reread from first configuration file
      $cf_section = "global";

      while ($cf_file = next_config_file())

      if ($old_configuration_file = @file($cf_file)) {

         $new = array();

         $last_cf_directive = "#";

         foreach ($old_configuration_file as $line) {

            if (preg_match('/^\s*(\w[-_.:\w\d]*)\s*=?(.*?)$/', $line, $uu)) {
               $cf_directive = strtolower(trim($uu[1]));
               $cf_args = trim($uu[2]);

               #-- append new directive not found in current config file
               if ($cf_directive != $last_cf_directive) {
                  add_missing_directives($last_cf_directive);
                  $last_cf_directive = $cf_directive;
               }
   
               #-- replace config files` lines with submitted values
               if (isset($directive[$cf_section]))
               foreach ($directive[$cf_section] as $dname => $darray) {

                  if (strtolower($dname) == $cf_directive) {

                     $act_divs = count(@$cf[$cf_section][$cf_directive]);

                     $dval = @$directive[$cf_section][$dname][$act_divs];
                     $line = ($dname . " = " . $dval . "\n");
                     $cf_args = $dval;

                     unset($directive[$cf_section][$dname][$act_divs]);
                     remove_empty_nodes($directive[$cf_section]);

                     #-- echo "last] $cf_section :: $cf_directive [$act_divs] ?= $dval<br>";
                  }
               }

               #-- save values in config array
               $cf[$cf_section][$cf_directive] = @array_merge(
                  $cf[$cf_section][$cf_directive],
                  array( $cf_args )
               );

            }
            else {
               if (preg_match('/^\s*\[([-_. \w\d]+)\]\s*$/', $line, $uu)) {
                  if ($cf_section != $uu[1]) {
#--echo "add missing directives of section $cf_section<br>";
                     add_missing_directives();
                  }
                  $cf_section = $uu[1];
               }
               else {
                  if (trim($line) == "") {
#--echo "add missing directives before blank line<br>";
                     add_missing_directives($last_cf_directive);
                  }
               }
            }
   
            $new[] = $line;

         }

         #-- new vhost section
         if (($add_vhost = @$_REQUEST["add_vhost"]) && ($which == "NW")) {
            if (strpos($cf_file, "vhosts") >= 1) {

               $docroot = @$HTTP_SERVER_VARS["DOCUMENT_ROOT"];
               $docroot = getcwd();
               
               $new[] = "\n[" . $add_vhost . "]\n" .
                 "DocumentRoot = " . $docroot . "\n";

               $cf[$add_vhost]["documentroot"][0] = $docroot;

               $config_page = ":" . $add_vhost;

            }
         }

         #-- save
         if ((@$_REQUEST["save"])) {
            if (is_writeable($cf_file) && ($f_cf = fopen($cf_file, "w"))) {
               fwrite($f_cf, implode("", $new));
               fclose($f_cf);
#-$o .= implode("", $new);
            }
            else {
               @$_MESSAGE .= "<font color=\"#771122\">'$cf_file' is not writeable!</font><br><br>";
            }
         }
      }

      add_missing_directives();
   }

 
   # -- add [vhosts] (temporarily) as configuration pages ---------------
   $configuration_pages["ADD"] = array();
   foreach ($cf as $section => $divs) {
      if ($section != $DEFAULT_SECTION) {
         if ($which == "NW") {
            $configuration_pages["ADD"][":$section"] = $CONFIGPAGE_ADD_NW_VHOST;
         }
         else {
            $configuration_pages["ADD"][":$section"] = $CONFIGPAGE_ADD_DOC;
         }
         foreach ($divs as $dname => $dcont) {
            if (! preg_match("/^log|servername|serveralias|documentroot$/i", $dname)) {
               $configuration_pages["ADD"][":$section"][$dname] = "magic";
            }
         }
      }
   }

   #-- which pages to list
   if (file_exists($T["NW"]["CONFIG_DIR"])) {
      $page_order = array("NW");
   }
   switch ($which) {
      case "PHP":
          $page_order[] = "PHP";
          $page_order[] = "ADD";
          break;
      case "NW":
          $page_order[] = "ADD";
          $page_order[] = "PHP";
          break;
      default:     
          $page_order[] = "PHP";
          $page_order[] = "$which";
          break;
   }


#-- echo "<pre>"; print_r($directive); #print_r($cf); print_r($configuration_pages); echo "</pre>";


?><!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
  <title>nanoweb online configuration</title>
  <style type="text/css"><!--
     body { font-family:Verdana,Times,"Times New","Times New Roman"; }
     .box { border:solid 1px #000000; }
     a { text-decoration:none;color:#3333cc; }
     input.save { text-align:right; text-alignment:right;
background-color:#aaaaee; }
  //--></style>
</head>
<body bgcolor="#ffffff">
  <table width="680" bgcolor="#dddddd" border="0" cellpadding="5" cellspacing="20" summary="list of pages on te left side, actual configuration directives on the right"><colgroup width="680"><col width="160"><col width="520"></colgroup>
  <tr><td colspan="2" bgcolor="#6666bb" class="box" valign="middle" align="center"><b><big>nanoweb online configuration</big></b></td></tr>
  <tr>
  <td bgcolor="#eeeeee" class="box" valign="top" align="left" width="160">
     <?php



      #-- list config pages
      $combined_pages = array();
      foreach ($page_order as $sub) {

         foreach ($configuration_pages[$sub] as $id => $uu) {

            if ($sub == "ADD") { $sub = $which; }

            $title = $id;
            if ($id[0] == ":") {
               $title = '&middot;&nbsp;' . ltrim($id, ":");
            } else {
               $title = "<b>$title</b>";
            }

            echo '<div' . ($id == $config_page ? ' style="background-color:#ccccee" bgcolor="#ccccee"' : '') . '>';
            echo '<a href="' . $PHP_SELF . '?page=' . $sub . "/" .
                 urlencode($id) . '">' . $title . "</a>";
            echo "</div>\n";
         }

      }



     ?>
  </td>
  <td bgcolor="#eeeeee" class="box" valign="top" align="left" width="520">
     <?php

         # -- [global] or [vhost]
         $cf_section = $DEFAULT_SECTION;

         if (@$configuration_pages["ADD"][$config_page]) {
            # -- not neccessary anymore because of "ADD":  &&is_array($cf[ltrim($config_page, ":")])) {
            $cf_section = ltrim($config_page, ":");
         }


         #-- info msg from init
         echo @$_MESSAGE;
         #-- echo "<pre>";print_r($cf);echo "</pre>";


         #-- output config page
         if (! ($def = @$configuration_pages[$which][$config_page])) {
            echo "internal script error<br>";
         }
         else {

            #-- submit form
            echo "<form action=\"$PHP_SELF\" method=\"POST\">\n";
            echo "   <input type=\"hidden\" name=\"page\" value=\"$which/$config_page\">\n";

            #-- go thru directive names on this config page
            foreach ($def as $directive => $ddesc) {

               #-- super-simple auto directive names
               if (strlen($directive) == 1) {
                  $directive = $ddesc;
                  $ddesc = "magic";
               }

               #-- print html help text or directive name, link
               if ((strpos($directive, "html") === 0) && ($directive !== "html_errors")) {
                  echo $ddesc;
                  continue;
               }
               else {
                  $link = $T[$which]["DOCREF"] . $directive;
                  switch ($which) {
                     case "NW": break;
                     case "PHP": $link = $T[$which]["DOCREF"] . strtr($directive, "_", "-"); break;
                     default: $link = "http://www.google.com/search?q={$which}+{$directive}";
                  }
                  echo "<a href=\"$link\">$directive</a>:<br>";
               }


               #-- values array
               $value = @$cf[$cf_section][strtolower($directive)];

               #-- determine type for "auto"
               if (($ddesc == "auto") || ($ddesc == "magic") || ($ddesc == "*") || ($ddesc === "")) {
                  if (is_array($value) && (count($value) >= 2)) {
                     $ddesc == "multiple";
                  }
                  else {
                     foreach (array("On|Off", "true|false", "Yes|No", "1|0", "enabled|disabled") as $ddesc) {
                        if (preg_match("/^{$ddesc}$/i", @$value[0])) {
                           $ddesc .= "|";
                           break;
                        }
                        $ddesc = "string";
                     }
                     if ($ddesc == "1|0|") { $ddesc = "boolean"; }
                  }
               }


               #-- first value (from array)
               $value = htmlentities(@$value[0]);


               #-- print input boxes depending on type
               if (($ddesc == "boolean") || (strpos($ddesc, "|") !== false)) {

                  #-- yes/no selection
                  echo "   <select name=\"directive[$cf_section][$directive][0]\">";
                  $options = explode("|", $ddesc);
                  if (count($options) >= 3) {
                     foreach ($options as $opt) {
                        if ($opt !== "") {
                           echo '<option value="' . $opt . '"' .
                              ((strtolower($value) == strtolower($opt)) ? " selected" : "") .
                              '>' . $opt . '</option>';
                        }
                     }
                  }
                  else {
                     $no = "No"; $yes = "Yes";
                     if (count($options) >= 2) {
                        list($no, $yes) = $options;
                     }
                     echo '<option value="0">' . $no . '</option>';
                     echo '<option value="1"' . ($value ? " selected" : "") . '>' . $yes . '</option>';
                  }
                  echo "</select>\n";

               }

               #-- input list
               elseif ($ddesc == "multiple") {

                  $index = -1;
                  if (count(@$cf[$cf_section][strtolower($directive)]))
                  foreach (@$cf[$cf_section][strtolower($directive)] as $index => $dval) {
                     $dval = htmlentities($dval);
                     echo "   <input size=\"42\" name=\"directive[$cf_section][$directive][$index]\" value=\"" . $dval . "\">";
                     echo "<input type=\"submit\" name=\"remove_directive[$cf_section][$directive][$index]\" value=\"Remove\"><br>\n";
                  }
                  $index++;
                  echo "   <input size=\"42\" name=\"directive[$cf_section][$directive][$index]\" value=\"\">";
                  echo "<input type=\"submit\" name=\"save\" value=\"Add\">\n";
               }

               #-- single field
               else {

                  #-- just a string input field
                  echo "   <input size=\"42\" name=\"directive[$cf_section][$directive][0]\" value=\"$value\">\n";
               }


               echo "   <br><br>\n";
            }

            #-- [save] button
            echo "   <input class=\"save\" type=\"submit\" name=\"save\" value=\"Save Changes\">\n";
            echo "   </form>\n";

         }

     ?>
  </tr></table>
</body>
</html>